<?php
# stats.php - Statistics
#
# Written by
#  Francisco Burzi
#  Patrik Wallstrm <pawal@blipp.com>
# Rewritten by
#  Aron Bostrm <aron@linux.se>
#
# This file is part of Gnuheter.
# See the file README for copyright notice.
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
#  02111-1307  USA.
#
# $Id: stats.php,v 1.2 2002/06/04 12:42:24 pawal Exp $

/* inkluderar ndvndiga filer. counter_lib anvnds bara fr att visa nuvarande beskarens OS och lsare. Kan tas bort nr betatestning r klar. */
include('mainfile.php');
include('header.php');
include_once("counter_lib.php");

/* Total r det vrde den gamla statistiken hade nr den tas/togs ur bruk.*/
$total = 314;

/* stat_open_table r en funktion so ppnar en ruta med svart ram och vit botten som endast finns p statistik-sidan. 
 Denna funktion borde knske ersttas av ngot bttre, och mer anpassningsbart.*/
function stat_open_table() { ?>
<table cellspacing="0" cellpadding="2" border="0" bgcolor="#000000"><tr><td colspan="2">
<table cellspacing="0" cellpadding="3" border="0" bgcolor="#ffffff">
<?
}

/* stat_close_table stnger en ruta med statistik i.*/
function stat_close_table() {
    echo "</table></td></tr></table>\n";
}


/* Ritar bild om det finns. */
function img($bild)
{
	if ($bild!="ingen")
		return "<img src=\"images/stats/$bild\" border=\"0\" alt=\"\">&nbsp;";
	else
		return "";
}


/* funktionen rita($namn,$antal,$totalt,$bild) ritar upp en post i statistiken fr Webblsare eller Operativsystem.
 $namn r den den text som ska visas, $bild r den bild som ska visas, "ingen" anvnds om man inte vill ha bild.
 $totalt r totala antalet sidtrffar, anvnds fr att berkna hur stor andel som aktuell post utgr. Parametern br vara satt till $hits.
 $antal r antalet trffar som aktuell post har ftt.*/
function rita($namn,$antal,$totalt,$bild)
{
	$ut="<tr><td>";
	$ut.=img($bild);
	$ut.="$namn: </td><td><img src=\"images/leftbar.png\" height=14 width=7 alt=\"\">";
	$ut.="<img src=\"images/mainbar.png\" alt=\"\" height=14 width=".substr(200*$antal/$totalt,0,5).">";
	$ut.="<img src=\"images/rightbar.png\" height=14 width=7 alt=\"\"> ".substr(100*$antal/$totalt,0,5)." % ($antal)</td></tr>\n";
	echo $ut;
}


/* Information till beskaren om vilket OS och vilken lsare den har. Statistik ver totala antalet sidtrffar.
 Denna del anvnds mest fr buggtestningsperioden.*/
$dkn = mysql_query("SELECT count FROM counter_ny WHERE typ=0");
if (!$dkn) { echo mysql_errno(). ": ".mysql_error(). "<br>";	exit(); }
$rad = mysql_fetch_object($dkn);
$hits=$rad->count;
mysql_free_result($dkn);
$total+=$hits;
$dkn = mysql_query("SELECT bild, var FROM counter_ny WHERE typ=1 && pid=".valla($HTTP_USER_AGENT)."");
if (!$dkn) { echo mysql_errno(). ": ".mysql_error(). "<br>";	exit(); }
$rad = mysql_fetch_object($dkn);
$valla=$rad;
mysql_free_result($dkn);
$dkn = mysql_query("SELECT bild, var FROM counter_ny WHERE typ=2 && pid=".op_sys($HTTP_USER_AGENT)."");
if (!$dkn) { echo mysql_errno(). ": ".mysql_error(). "<br>";	exit(); }
$rad = mysql_fetch_object($dkn);
$os=$rad;
mysql_free_result($dkn);
echo "<div align=\"center\">
	<table cellspacing=\"0\" cellpadding=\"2\" border=\"0\" bgcolor=\"#000000\"><tr><td colspan=\"2\">
	<table cellspacing=\"0\" cellpadding=\"3\" border=\"0\" bgcolor=\"#ffffff\"><tr><td>
	Vi har ftt <b>$total</b> trffar frn och med $startdate<br>
	Vi har ftt in <b>$hits</b> trffar sedan vi nollstllde statistiken.<br>
	Du anvnder webblsare: <br>'".img($valla->bild)." $valla->var'<br>
	P operativsystemet: <br>'".img($os->bild)." $os->var'<br>
	Med anvndaridentifieringen: <br>'".getenv("HTTP_USER_AGENT")."'.<br>
	Om detta inte stmmer var vnlig kontakta
	<A HREF=\"mailto:gnuheter-dev@mail.freesoftware.fsf.org\">utvecklarna</a>.</td></tr></table></td></tr></table>
	<br><br></div>";


/* Hmtar data ur dataasen och presenterar webblsare (typ=1) */
$dkn = mysql_query("SELECT bild, var, count FROM counter_ny WHERE typ=1 ORDER BY count DESC");
if (!$dkn) { echo mysql_errno(). ": ".mysql_error(). "<br>";	exit(); }
$i=mysql_num_rows($dkn);
if ($i>=1)
{
	echo "<div align=\"center\">";
	stat_open_table();
	echo "<font color=\"#ffffff\"><div align=\"center\"><b>Webblsare</b></div>\n";
}
for ($j=0;$j<$i;$j++)
{
	mysql_data_seek($dkn,$j);
	$rad = mysql_fetch_object($dkn);
	rita($rad->var,$rad->count,$hits,$rad->bild);
}
mysql_free_result($dkn);
if ($i>=1)
{
	echo "</font>";
	stat_close_table();
	echo "<br><br>";
}


/* Hmtar data ur dataasen och presenterar OS (typ=2) */
$dkn = mysql_query("SELECT bild, var, count FROM counter_ny WHERE typ=2 ORDER BY count DESC");
if (!$dkn) { echo mysql_errno(). ": ".mysql_error(). "<br>";	exit(); }
$i=mysql_num_rows($dkn);
if ($i>=1)
{
	echo "<div align=\"center\">";
	stat_open_table();
	echo "<font color=\"#ffffff\"><div align=\"center\"><b>Operativsystem</b></div>\n";
}
for ($j=0;$j<$i;$j++)
{
	mysql_data_seek($dkn,$j);
	$rad = mysql_fetch_object($dkn);
	rita($rad->var,$rad->count,$hits,$rad->bild);
}
mysql_free_result($dkn);
if ($i>=1)
{
	echo "</font>";
	stat_close_table();
	echo "<br><br>";
}


/* vrig information som ska visas hmtas hr.*/
$result = mysql_query("SELECT COUNT(*) FROM users");
list ($unum) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM authors");
list ($anum) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM stories");
list ($snum) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM comments");
list ($cnum) = mysql_fetch_row($result);
/* $result = mysql_query("SELECT COUNT(*) FROM sections");
 list ($secnum) = mysql_fetch_row($result);
 $result = mysql_query("SELECT COUNT(*) FROM seccont");
 list ($secanum) = mysql_fetch_row($result); */
$result = mysql_query("SELECT COUNT(*) FROM queue");
list ($subnum) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM topics");
list ($tnum) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM links_links");
list ($links) = mysql_fetch_row($result);
	$result = mysql_query("SELECT COUNT(*) FROM links_categories");
list ($cat1) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM links_subcategories");
list ($cat2) = mysql_fetch_row($result);
$cat = $cat1+$cat2;


/* vrig information visas hr. */
stat_open_table();
echo "<font color=\"#ffffff\"><div align=\"center\"><b>Diverse statistik</b></div></font>\n";
echo "<tr><td><img src=\"images/stats/users.png\" border=\"0\">&nbsp;Registrerade anvndare: </td><td><b>$unum</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/authors.png\" border=\"0\">&nbsp;Aktiva skribenter: </td><td><b>$anum</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/news.png\" border=\"0\">&nbsp;Publicerade artiklar: </td><td><b>$snum</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/topics.png\" border=\"0\">&nbsp;Aktiva mnen: </td><td><b>$tnum</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/comments.png\" border=\"0\">&nbsp;Postade kommentarer: </td><td><b>$cnum</b></td></tr>\n";
/*echo "<tr><td><img src=\"images/stats/sections.png\" border=\"0\">&nbsp;Specialavdelningar: </td><td><b>$secnum</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/articles.png\" border=\"0\">&nbsp;Artiklar i avdelningar: </td><td><b>$secanum</b></td></tr>\n";*/
echo "<tr><td><img src=\"images/stats/topics.png\" border=\"0\">&nbsp;Lnkar i lnkdatabasen: </td><td><b>$links</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/sections.png\" border=\"0\">&nbsp;Kategorier i lnkdatabasen: </td><td><b>$cat</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/waiting.png\" border=\"0\">&nbsp;Nyheter i publiceringskn: </td><td><b>$subnum</b></td></tr>\n";
/*echo "<tr><td><img src=\"images/stats/sections.png\" border=\"0\">&nbsp;Version av PHP-Nuke: </td><td><b>$Version_Num</b></td></tr>\n";*/
html_page_foot();
echo "<br><br></div>";

include('footer.php');

?>
